
//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <iostream>
#include <math.h>
#include <stdio.h>

#include "affine.h"

using namespace std ;
using namespace keyFlow ;



affine::affine(Double argA,Double argB) : function1() {
  a=argA;
  b=argB;
  
  orderDeriv=0;
}



affine::affine(const affine &in) : function1() {
  a=in.a;
  b=in.b;
  
  orderDeriv=in.orderDeriv;
}



affine::~affine(void) {
}



Double affine::value(Double arg) const {  
  if (orderDeriv==0)
    return(a*arg+b);
  else if (orderDeriv==1)
    return(a);
  else
    return(0.0);
}



Double affine::deriv(Double arg) const {
  if (orderDeriv==0)
    return(a);
  else
    return(0.0);
}



void affine::setArgA(Double x) {
  a=x;
}



Double affine::getArgA(void) const {
  return(a);
}



void affine::setArgB(Double x) {
  b=x;
}



Double affine::getArgB(void) const {
  return(b);
}



function1* affine::makeCopy(void) const {
   return(new affine(*this));
}



function1* affine::makeFunctionDeriv(void) const {
  affine *tmp=new affine(*this);
  tmp->orderDeriv++;
  return(tmp);
}



string affine::strPrint(void) const {
  char cbuf[STRING_LENGTH];
  string sbuf;

  sprintf(cbuf,"affine");
  sbuf=cbuf;
  for (int i=0;i<orderDeriv;i++) 
    sbuf+="'";
  sprintf(cbuf,"(a=%g,b=%g,arrayArg)",a,b);
  sbuf+=cbuf;
  
  return sbuf;
}  
  
