#ifndef KEYFLOW_AFFINE_H
#define KEYFLOW_AFFINE_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <string>

#include "function1.h"



namespace keyFlow {
  
  using namespace keyFE2 ;
  
  class affine : public function1 {
    
    protected :
      
      Double a ;
      Double b ;
      
      Int orderDeriv ;
    
    public :
      
      affine(Double argA=1.0,Double argB=1.0);
      affine(const affine &in);
      ~affine(void);
      
      Double value(Double) const ;
      Double deriv(Double) const ;
      
      void setArgA(Double);
      Double getArgA(void) const ;
      void setArgB(Double);
      Double getArgB(void) const ;
      
      function1* makeCopy(void) const ;
      
      function1* makeFunctionDeriv(void) const ;
      
      std::string strPrint(void) const ;

  } ;
  
}

#endif
