#ifndef KEYFLOW_KINCOND1DXY_H
#define KEYFLOW_KINCOND1DXY_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include "Array.h"
#include "Field.h"
#include "GlobLoc.h"
#include "Integ.h"
#include "TensorCoordSys.h"
#include "TimeDep.h"



namespace keyFlow {
  
  using namespace keyFE2 ;
  
  class kinCondXY : public Array {
    
    public:
      
      // general data:
      
      TimeDep localTimeDep ;
      
      // basic ArrayFields:
      
      Array CartCoordinates ;
      Array coordinates ;
      Array velocities ;
    
      Array coordinatesTimeDeriv ;
      
      Array X;
      Array Y;
      Array testX;
      Array testY;
      Array CartX;
      Array CartY;
      Array testCartX;
      Array testCartY;      
      
      Field refTCoordField;
      Array refTCoord;

      // Quantities related to coordinates systems:
      
      GlobLoc gl ;
      TensorCoordSys tcs ;
      Integ itg ;
      
      GlobLoc CartGL ;
      TensorCoordSys CartTCS ;
      Integ CartITG ;
      
      // Quantities mainly related to equations:
      
      Array surfaceTension ;
              
      // Constructor:
      
      kinCondXY(paramList PL) ;
      
  } ;
    
}

#endif
