#ifndef ARRAYLIST_H
#define ARRAYLIST_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <iostream>

#include "types/params.h"
#include "types/types.h"

namespace keyFE2 {
  
  class array ;
  
  class arrayList {
    
    private :
      
      Int capacity ;
      Int size ;
      array **data ;
    
    public :
      
      arrayList(void) ;
      arrayList(const arrayList &in) ;
      ~arrayList(void) ;
    
      void init(void) ;
      void pushBack(array *a) ;
      void insert(array *a) ;
      void sort(void) ;
      void write(std::ostream &myCout) const ;
      
      // operators :
      
      void operator=(const arrayList &in) ;
      void operator+=(const arrayList &in) ;
      arrayList operator+(const arrayList &in) ;
      array* operator[](Int index) const ;
      
  } ;
  
}

#endif
