#ifndef CONSTR1_H
#define CONSTR1_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include "constr_base.h"
#include "types/types.h"

namespace keyFE2 {
  
  class array ;
  class domain ;
  class globLoc ;
  class paramList ;
  class tensorCoordSys ;
  
  class constr1 : public constr {
    
    private :
      
      array *test ;
      array *equation ;
      array *expr ; // Accumulation of test and equation.
      domain *dom ;
      globLoc *GL ;
      tensorCoordSys *TCS ;
      Int integRule ;
    
    public :
      
      constr1(void) ;
      constr1(paramList PL) ;
      constr1(const constr1 &in) ;
      ~constr1(void) ;
      
      void operator=(const constr1 &in) ;
      
      void setTest(array *arg) ;
      void setEquation(array *arg) ;
      void setExpr(array *arg) ;
      void setDomain(domain *arg) ;
      void setGlobLoc(globLoc *arg) ;
      void setTCS(tensorCoordSys *arg) ;
      
      void checkTestEquationMatch(void) ;
      
      void generateExprCollect(bool makeValue=true,bool makeDeriv=true) ;
      
      virtual printTree getPrintTree(bool values) const ;
      
  } ;
  
}

#endif

