#ifndef CONSTR2_H
#define CONSTR2_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include "constr_base.h"
#include "types/types.h"

namespace keyFE2 {
  
  class array ;
  class domain ;
  class globLoc ;
  class paramList ;
  class tensorCoordSys ;
  
  class constr2 : public constr {
    
    private :
      
      array *leftTest ;
      array *leftEquation ;
      array *leftExpr ; 
      domain *leftDom ;
      
      array *rightTest ;
      array *rightEquation ;
      array *rightExpr ; 
      domain *rightDom ;
      
      globLoc *GL ;
      tensorCoordSys *TCS ;
      
      Int integRule;
      
    public :
      
      constr2(void) ;
      constr2(paramList PL) ;
      constr2(const constr2 &in) ;
      ~constr2(void) ;
      
      void operator=(const constr2 &in) ;
      
      void setLeftTest(array *arg) ;
      void setLeftEquation(array *arg) ;
      void setLeftExpr(array *arg) ;
      void setLeftDomain(domain *arg) ;
      void setRightTest(array *arg) ;
      void setRightEquation(array *arg) ;
      void setRightExpr(array *arg) ;
      void setRightDomain(domain *arg) ;
      void setGlobLoc(globLoc *arg) ;
      void setTCS(tensorCoordSys *arg) ;
      
      void checkTestEquationMatch(void) ;
      
      void generateExprCollect(bool makeValue=true,bool makeDeriv=true) ;
      
      virtual printTree getPrintTree(bool values) const ;
      
  } ;
  
}

#endif


