#ifndef TENSOR_COORDSYS_H
#define TENSOR_COORDSYS_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <string>

#include "types/types.h"
#include "types/params.h"

namespace keyFE2 {
  
  class Array ;
  class scal ;
  class object ;
  class param ;
  class paramList ;
  class tensorCoordSys ;
  
  class TensorCoordSys {
    
    private :
      
      void *data;
    
    public :
      
      TensorCoordSys(void) ;
      TensorCoordSys(const TensorCoordSys&) ;
      TensorCoordSys(param P) ;
      TensorCoordSys(paramList PL) ;
      ~TensorCoordSys(void) ;
      
      void setData(tensorCoordSys*) ;
      tensorCoordSys* getData(void) const ;
      void setName(std::string s) ;
      std::string getName(void) const ;
      
      void write(void) const ;
      void writeValues(void) const ;
      void write(std::ostream &out) const ;
      void writeValues(std::ostream &out) const ;
      
      void operator=(const TensorCoordSys &) ;
      
  } ;
  
  TensorCoordSys build1DCartesianTCS(Array &Coord) ;
  TensorCoordSys build2DCartesianTCS(Array &Coord) ;
  TensorCoordSys build3DCartesianTCS(Array &Coord) ;
  TensorCoordSys buildRZTCylindricalTCS(Array &Coord) ;
  
}

#endif
    
    
    
    
