
//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <iostream>
#include <stdio.h>

#include "DConst.h"

using namespace std ;
using namespace keyFE2 ;



DConst::DConst(void) : function1() {
   DParam=0.0;
}



DConst::DConst(Double factor) : function1() {
   DParam=factor;
}



DConst::DConst(const DConst &in) : function1() {
   DParam=in.DParam;
}



DConst::~DConst(void) {
}



Double DConst::value(Double arg) const {
   return(DParam);
}



Double DConst::deriv(Double arg) const {
   return(0.0);
}



void DConst::setDParam(Double x) {
   DParam=x;
}



Double DConst::getDParam(void) const {
   return(DParam);
}



function1* DConst::makeCopy(void) const {
   return(new DConst(*this));
}



function1* DConst::makeFunctionDeriv(void) const {
   return(new DConst(0.0));
}



string DConst::strPrint(void) const {
  char cbuf[STRING_LENGTH];
  sprintf(cbuf,"constFunction(%g,arrayArg)",getDParam());
  return cbuf;
}
 
