
//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <iostream>
#include <stdio.h>

#include "DMult.h"
#include "DConst.h"

using namespace std ;
using namespace keyFE2 ;



DMult::DMult(void) : function1() {
   DParam=0.0;
}



DMult::DMult(Double factor) : function1() {
   DParam=factor;
}



DMult::DMult(const DMult &in) : function1() {
   DParam=in.DParam;
}



DMult::~DMult(void) {
}



Double DMult::value(Double arg) const {
   return(DParam*arg);
}



Double DMult::deriv(Double arg) const {
   return(DParam);
}



void DMult::setDParam(Double x) {
   DParam=x;
}



Double DMult::getDParam(void) const {
   return(DParam);
}



function1* DMult::makeCopy(void) const {
   return(new DMult(*this));
}



function1* DMult::makeFunctionDeriv(void) const {
   return(new DConst(DParam));
}



string DMult::strPrint(void) const {
  char cbuf[STRING_LENGTH];
  sprintf(cbuf,"%g*arrayArg",getDParam());
  return cbuf;
}
 
