#ifndef DTANH_H
#define DTANH_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include "function1.h"

namespace keyFE2 {
  
  class DTanh : public function1 {
    
    protected :
      
      Double TanhFact;
      Double ArgFact;
    
    public :
      
      DTanh(Double tanhfact=1.0,Double argfact=1.0);
      DTanh(const DTanh &in);
      ~DTanh(void);
      
      Double value(Double) const ;
      Double deriv(Double) const ;
      
      void setTanhFact(Double);
      Double getTanhFact(void) const ;
      void setArgFact(Double);
      Double getArgFact(void) const ;
      
      function1* makeCopy(void) const ;
      
      function1* makeFunctionDeriv(void) const ;
      
      std::string strPrint(void) const ;

  } ;
  
}

#endif

