#ifndef Dpw_CONST_2_H
#define Dpw_CONST_2_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include "function1.h"

namespace keyFE2 {
  
  class DpwConst2 : public function1 {
    
    protected :
      
      Double PA;
      Double X1;
      Double P12;
      Double X2;
      Double PB;
    
    public :
      
      DpwConst2(void);
      DpwConst2(Double pa,
                Double x1,Double p12,
                Double x2,Double pb);
      DpwConst2(const DpwConst2 &in);
      ~DpwConst2(void);
      
      Double value(Double) const ;
      Double deriv(Double) const ;
      
      void setPA(Double);
      Double getPA(void) const ;
      void setX1(Double);
      Double getX1(void) const ;
      void setP12(Double);
      Double getP12(void) const ;
      void setX2(Double);
      Double getX2(void) const ;
      void setPB(Double);
      Double getPB(void) const ;
      
      function1* makeCopy(void) const ;
      
      function1* makeFunctionDeriv(void) const ;
      
      std::string strPrint(void) const ;

  } ;
  
}

#endif
