#ifndef FUNCTION1_H
#define FUNCTION1_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <string>

#include "types/allTypes.h"
#include "util/utils.h"

namespace keyFE2 {
  
  class function1 : public virtual parents {
    
    private:
      
      static bool dynamicallyAllocated ;
    
    public:
      
      function1(void);
      virtual ~function1(void);
      
      void* operator new(size_t) ;
      void operator delete(void*) ;
      // Two forbidden operators:
      void* operator new[](size_t) ;
      void operator delete[](void*) ;
    
      virtual Double value(Double) const ;
      virtual Double deriv(Double) const ;
    
      virtual function1* makeCopy(void) const ;
    
      virtual function1* makeFunctionDeriv(void) const ;
      
      virtual std::string strPrint(void) const ;
    
  } ;
  
}

#endif
