#ifndef OBJECT_H
#define OBJECT_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <string>

#include "types/types.h"

namespace keyFE2 {

  class object ;
  
  class Object {
    
    private :
    
      void *data ;
      Int direct ;
    
    public :
      
      Object(void) ;
      Object(const Object &in) ;
      ~Object(void) ;
      
      void setData(object*) ;
      object* getData(void) const ;
      void setDirect(Int) ;
      Int getDirect(void) const ;
      
      Int getType(void) const ;
      std::string getTypeName(void) const ;
      Int getDim(void) const ;
      
  } ;
  
}

#endif


