
//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <iostream>
#include <iomanip>
#include <typeinfo>
#include <string>
#include <stdio.h>

#include "print.h"
#include "printTree.h"
#include "err/err.h"
#include "types/params.h"

using namespace std ;
using namespace keyFE2 ;



bool print::boolWrite = true ;



void print::setBoolWrite(bool b) {
  boolWrite=b;
}



printTree print::getPrintTreeData(void) const {
  errThrow("print::getPrintTreeData",
	   string("cannot be called with this type of object : ")
	   +typeid(*this).name()+".");
}



printTree print::getPrintTreeValues(void) const {
  errThrow("print::getPrintTreeValues",
	   string("cannot be called with this type of object : ")
	   +typeid(*this).name()+".");
}



printTree print::getPrintTree(bool values) const {
  errThrow("print::getPrintTree",
	   string("cannot be called with this type of object : ")
	   +typeid(*this).name()+".");
}



printTree print::getPrintTreeSummary(void) const {
  errThrow("print::getPrintTreeSummary",
	   string("cannot be called with this type of object : ")
	   +typeid(*this).name()+".");
}



printTree print::getPrintTreeSummary(char *str) const {
  try {
    string sbuf;
    printTree pt;
    
    sbuf=str;
    sbuf+=":";
    pt=sbuf;
    pt+=getPrintTreeSummary();
    
    return pt;
  }
  catchAll("printTree print::getPrintTreeSummary(char *str) const","")
}



printTree print::getFirstPrintTree(char *strName,bool values) const {
  try {
    char cbuf[STRING_LENGTH];
    string sbuf;
    printTree pt0,ptArg;
    
    const_cast<print*>(this)->accessNbrInc();
    if (getAccessNbr()==1) {
      sbuf=strName;
      sbuf+=":";
      pt0=sbuf;
      ptArg=getPrintTree(values);
      ptArg=pt0+ptArg;
    }
    else {
      sprintf(cbuf,"%s: ",strName);
      sbuf=cbuf;
      ptArg=sbuf;
      sprintf(cbuf,"%p named \"%s\" (access number %d)",
	      static_cast<const void*>(this),
	      getName().c_str(),getAccessNbr());
      sbuf=cbuf;
      ptArg+=sbuf;
      sbuf="   ";
      ptArg+=sbuf;
    }      
    return(ptArg);
  }
  catchAll("printTree print::getFirstPrintTree(char *strName,bool values) const","")
}



void print::write(ostream &os) const {
  try {
    if (boolWrite) {
      printTree pt;
      
      const_cast<print*>(this)->accessNbrInit();
      pt=getPrintTree(false);
      pt.write(os);
    }
  }
  catchAll("void print::write(ostream &os) const","")
}



void print::write(void) const {
  try {
    write(cerr);
  }
  catchAll("void print::write(void) const","")
}



void print::writeValues(ostream &os) const {
  try {
    if (boolWrite) {
      printTree pt;
      
      const_cast<print*>(this)->accessNbrInit();
      pt=getPrintTree(true);
      pt.write(os);
    }
  }
  catchAll("void print::writeValues(ostream &os) const","")
}



void print::writeValues(void) const {
  try {
    writeValues(cerr);
  }
  catchAll("void print::writeValues(void) const","")
}

