#ifndef PRINT_H
#define PRINT_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <iostream>

#include "util/name.h"
#include "util/newPoint.h"

namespace keyFE2 {
  
  class printTree;
  
  class print : public virtual name, public virtual newPoint {
    
    private :
      
      static bool boolWrite;
    
    public :
      
      static void setBoolWrite(bool) ;
    
      virtual printTree getPrintTreeData(void) const ;
      virtual printTree getPrintTreeValues(void) const ;
      
      virtual printTree getPrintTree(bool values) const ;
      virtual printTree getPrintTreeSummary(void) const ;
      virtual printTree getPrintTreeSummary(char *str) const ;
      virtual printTree getFirstPrintTree(char *name,bool values) const ;
//      virtual printTree getFirstPrintTreeSummary(char *name) const ;
      
      virtual void write(std::ostream &os) const ;
      virtual void write(void) const ;
      virtual void writeValues(std::ostream &os) const ;
      virtual void writeValues(void) const ;
      
  } ;
  
}

#endif
    
    
