
//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <iostream>
#include <iomanip>
#include <typeinfo>

#include "parents.h"
#include "err/err.h"
#include "field/field_base.h"
#include "array/arrayField.h"
#include "array/arrayFilter.h"
#include "util/utils.h"



using namespace std ;
using namespace keyFE2 ;



bool parents::isOfType(string typeName) const {
  try {
    if (typeName=="field") {
      if (dynamic_cast<const field*>(this)!=NULL)
	return(true);
      else
	return(false);
    }
    else if (typeName=="arrayFilter") {
      if (dynamic_cast<const arrayFilter*>(this)!=NULL)
	return(true);
      else
	return(false);
    }
    else if (typeName=="arrayField") {
      if (dynamic_cast<const arrayField*>(this)!=NULL)
	return(true);
      else
	return(false);
    }
    else {
      errThrow("parents::isOfType",string("unrecognised type name :  ")
	       +typeName+".");
    }    
  }
  catchAll("bool parents::isOfType(string typeName) const","")
}



set<parents*> parents::getListOfType(string typeName) const {
  try {
    set<parents*> S;
    if (isOfType(typeName))
      S.insert(const_cast<parents*>(this));
    return(S);
  }
  catchAll("set<parents*> parents::getListOfType(string typeName) const","")
}



